require 'newt'
include Newt

COLVAL = [
  "black",
  "red",
  "green",
  "brown",
  "blue",
  "magenta",
  "cyan",
  "lightgray",
  "gray",
  "brightred",
  "brightgreen",
  "yellow",
  "brightblue",
  "brightmagenta",
  "brightcyan",
  "white"
]

init
cls
ss = getScreenSize
openWindow  (2, 2, ss[0] - 4, ss[1] - 4, "Test color")
lb1 = Listbox.new (0, 0, 6, FLAG_BORDER | FLAG_SCROLL)
lb1.AppendEntry ("rootFg", "rootFg")
lb1.AppendEntry ("rootBg", "rootBg")
lb1.AppendEntry ("borderFg", "borderFg")
lb1.AppendEntry ("borderBg", "borderBg")
lb1.AppendEntry ("windowFg", "windowFg")
lb1.AppendEntry ("windowBg", "windowBg")
lb1.AppendEntry ("shadowFg", "shadowFg")
lb1.AppendEntry ("shadowBg", "shadowBg")
lb1.AppendEntry ("titleFg", "titleFg")
lb1.AppendEntry ("titleBg", "titleBg")
lb1.AppendEntry ("buttonFg", "buttonFg")
lb1.AppendEntry ("buttonBg", "buttonBg")
lb1.AppendEntry ("actButtonFg", "actButtonFg")
lb1.AppendEntry ("actButtonBg", "actButtonBg")
lb1.AppendEntry ("checkboxFg", "checkboxFg")
lb1.AppendEntry ("checkboxBg", "checkboxBg")
lb1.AppendEntry ("actCheckboxFg", "actCheckboxFg")
lb1.AppendEntry ("actCheckboxBg", "actCheckboxBg")
lb1.AppendEntry ("entryFg", "entryFg")
lb1.AppendEntry ("entryBg", "entryBg")
lb1.AppendEntry ("labelFg", "labelFg")
lb1.AppendEntry ("labelBg", "labelBg")
lb1.AppendEntry ("listboxFg", "listboxFg")
lb1.AppendEntry ("listboxBg", "listboxBg")
lb1.AppendEntry ("actListboxFg", "actListboxFg")
lb1.AppendEntry ("actListboxBg", "actListboxBg")
lb1.AppendEntry ("textboxFg", "textboxFg")
lb1.AppendEntry ("textboxBg", "textboxBg")
lb1.AppendEntry ("actTextboxFg", "actTextboxFg")
lb1.AppendEntry ("actTextboxBg", "actTextboxBg")
lb1.AppendEntry ("helpLineFg", "helpLineFg")
lb1.AppendEntry ("helpLineBg", "helpLineBg")
lb1.AppendEntry ("rootTextFg", "rootTextFg")
lb1.AppendEntry ("rootTextBg", "rootTextBg")
lb1.AppendEntry ("emptyScale", "emptyScale")
lb1.AppendEntry ("fullScale", "fullScale")
lb1.AppendEntry ("disabledEntryFg", "disabledEntryFg")
lb1.AppendEntry ("disabledEntryBg", "disabledEntryBg")
lb1.AppendEntry ("compactButtonFg", "compactButtonFg")
lb1.AppendEntry ("compactButtonBg", "compactButtonBg")
lb1.AppendEntry ("actSelListboxFg", "actSelListboxFg")
lb1.AppendEntry ("actSelListboxBg", "actSelListboxBg")
lb1.AppendEntry ("selListboxFg", "selListboxFg")
lb1.AppendEntry ("selListboxBg", "selListboxBg")

lb2 = Listbox.new (22, 0, 6, FLAG_BORDER | FLAG_SCROLL)
i = 0
COLVAL.each do |c|
  lb2.add (c, i)
  i += 1
end

b1 = Button.new (-0, 6, "Ok")
b2 = Button.new (20, 6, "Cancel")
lb1.AddCallback (lb2) do |co1, co2|
  colors = getDefaultColors
  co2.SetCurrent (COLVAL.index(colors[co1.GetCurrent]))
end

f = Form.new (nil, nil, 0)
f.AddComponents (lb1, lb2, b1, b2)
f.Run

popWindow

f.Destroy
finished
