#!/usr/bin/env ruby

if $0 == "gtest.rb"
  require 'gnewt'
else
  require 'newt'
end

Newt::init
Newt::cls
Newt::openWindow(10, 5, 40, 15, "Checkboxes and Radio buttons")

checkbox = Newt::Checkbox.new(1, 1, "A checkbox", ' ', " *X")
rb0 = Newt::Radiobutton.new(1, 3, "Choice 1", 1)
rb1 = Newt::Radiobutton.new(1, 4, "Choice 2", 0, rb0)
rb2 = Newt::Radiobutton.new(1, 5, "Choice 3", 0, rb1)
entry = Newt::Entry.new(1, 7, "Entry", 20, Newt::FLAG_PASSWORD)
button = Newt::Button.new(1, 10, "Ok")

form = Newt::Form.new
form.AddComponents(checkbox, rb0, rb1, rb2, entry, button)
form.Run
Newt::finished

cbv = checkbox.GetValue
entryresult = entry.GetValue

form.Destroy

print "checkbox value: \'#{cbv}\'\n"
print "radio button picked: "
rc = rb0.GetCurrent
i = 0
[rb0, rb1, rb2].each do |r|
  if rc == r then
    print i, "\n"
  end
  i += 1
end
print "entry string: ", entryresult, "\n"
sleep 1

Newt::init
Newt::cls
Newt::winMessage ("Kondara MNU/Linux 1.1", "Ok", "Ruby/Newt\n", "Test Program\n", "\n", "Have fun!\n")
Newt::finished

Newt::init
Newt::cls
r = Newt::winChoice ("Kondara MNU/Linux 2000", "Ok", "Cancel", "Ruby/Newt\n", "Test Program\n", "\n", "Have fun!\n")
Newt::finished
p r

sleep 1

Newt::init
Newt::cls
r = Newt::winTernary ("Kondara MNU/Linux 2.0", "Ok", "Cancel", "Next", "Ruby/Newt\n", "Test Program\n", "\n", "Have fun!\n")
Newt::finished
p r
